import 'dart:collection';
import 'dart:ui';

import 'package:flutter_test/flutter_test.dart';
import 'package:mockito/annotations.dart';
import 'package:translations_loader/src/domain/repositories/translation_file_repository.dart';
import 'package:translations_loader/translations_loader.dart';

@GenerateMocks([], customMocks: [MockSpec<TranslationFileRepository>(as: #TranslationFileRepositoryMock)])
void main() {
//TODO
  const supportedLocales = [Locale.fromSubtags(languageCode: "en"), Locale.fromSubtags(languageCode: "hr")];
  final hrMap = HashMap<String, String>();
  final enMap = HashMap<String, String>();
  const appKey = "app";
  const assetsPath = "assets/i18n";

  setUpAll(() {
    hrMap[appKey] = "aplikacija";
    enMap[appKey] = "application";
  });

  group('error testing', () {
    test('given assets path is empty, throw exception', () {
      // arrange
      // act
      // assert
      expect(TranslationsLoader.loadTranslations(""), throwsException);
    });

    test('repository throws exception, return empty map', () async {
      // arrange
      //when(repository.loadTranslationFileByLocale(supportedLocales[0])).thenAnswer((_) => Future.error("roki"));
      //when(repository.loadTranslationFileByLocale(supportedLocales[1])).thenAnswer((_) => Future.error("roki"));
      // act
      // assert
      expect(TranslationsLoader.loadTranslations(assetsPath, supportedLocales), throwsException);
    });
  });

  group('success testing', () {
    test('repository returns value, return valid map', () async {
      // arrange
      //when(repository.loadTranslationFileByLocale(any)).thenAnswer((_) => Future.value(enMap));
      //when(repository.loadTranslationFileByLocale(supportedLocales[1])).thenAnswer((_) => Future.value(hrMap));

      // act
      //final translations = await loadTranslationsForLocales(supportedLocales, repository);
      // assert
      //expect(translations.isNotEmpty, true);
      //expect(translations["en"], {appKey: "application"});
    });
  });
}
